<?php
/**
 * -----------------------------------------
 * RSS Grabber free v2.0 - 11.12.2022
 * -----------------------------------------
 * @copyright Copyright 2011, Schubertmedia/Nico Schubert
 * @link http://www.php-space.info/rss-grabber/ - Dokumentation und Informationen rund um das PHP Script.
 * @version free v2.0 (PHP8.1)
 * @abstract
 * Das Script darf kostenlos verwendet werden. Es müssen aber alle Copyright Hinweise erhalten bleiben.
 * Für einen einmaligen Betrag von 9,95 EUR erhalten Sie die Premium-Version. In der Premium-Version sind keine
 * sichtbaren Copyright Hinweise mehr enthalten. Daduch unterstutzen Sie die Weiterentwiklung und würdigen diese Arbeit.
 */
if (function_exists("limitch") == false) {
    /**
     * @param string $value
     * @param int $lenght
     * @return string
     */
    function limitch(string $value, int $lenght): string
    {
        if (strlen($value) >= $lenght) {
            $limited = "";
            $limited .= substr($value, 0, $lenght);
            $limited .= "...";
            return stripslashes($limited);
        } else {
            return stripslashes($value);
        }
    }
}
if (function_exists("date_mysql2german") == false) {
    /**
     * @param string $pubDate
     * @return string
     */
    function date_mysql2german(string $pubDate = '0000-00-00 00:00:00'): string
    {
        if ($pubDate == "" || $pubDate == NULL) $pubDate = '0000-00-00 00:00:00';
        list($datum, $zeit) = explode(" ", $pubDate);
        list($jahr, $monat, $tag) = explode("-", $datum);
        list($stunde, $min, $sec) = explode(":", $zeit);
        $tage = array("Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag");
        return sprintf("%s den %02d.%02d.%04d um %02d:%02d:%02d Uhr", $tage[date("w", mktime($stunde, $min, $sec, $monat, $tag, $jahr))], $tag, $monat, $jahr, $stunde, $min, $sec);
    }
}
if (function_exists("addItem") == false) {
  /**
   * @param string $iso_to_utf
   * @param SimpleXMLElement|null $v
   * @param int $id
   * @param bool|mysqli $link
   * @param int $iArt
   * @return void
   */
  function addItem(string $iso_to_utf, ?SimpleXMLElement $v, int $id, bool|mysqli $link, $iArt = 1)
  {
    switch ($iArt) {
      case 1:
        // RSS 2.0
        if ($iso_to_utf == 1) {
          $v->link = ((@iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->link) != false) ? @iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->link) : $v->link);
          $v->title = ((@iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->title) != false) ? @iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->title) : $v->title);
          $v->description = ((@iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->description) != false) ? @iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->description) : $v->description);
        }
        $sql_select2 = "SELECT id FROM `feeds_post` WHERE `feeds_id` = '" . $id . "' AND `link`='" . mysqli_escape_string($link, $v->link) . "' LIMIT 1 ;";
        $query2 = mysqli_query($link, $sql_select2) or die(mysqli_errno($link));
        if (mysqli_num_rows($query2) == 0) {
          $v->pubDate = date("Y-m-d H:i:s", strtotime($v->pubDate));
          $sql_insert = "INSERT INTO `feeds_post` (`feeds_id`,`pubDate`,`link`,`title`,`description`) VALUES ('" . $id . "', 
        '" . mysqli_escape_string($link, $v->pubDate) . "', 
        '" . mysqli_escape_string($link, $v->link) . "', 
        '" . mysqli_escape_string($link, $v->title) . "', 
        '" . mysqli_escape_string($link, $v->description) . "');";
          mysqli_query($link, $sql_insert) or die(mysqli_errno($link));
        }
        break;
      case 2:
        // Atom
        if ($iso_to_utf == 1) {
          $v->title = ((@iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->title) != false) ? @iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->title) : $v->title);
          $v->description = ((@iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->description) != false) ? @iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->description) : $v->description);
        }
        $sql_select2 = "SELECT id FROM `feeds_post` WHERE `feeds_id` = '" . $id . "' AND `link`='" . mysqli_escape_string($link, $v->link) . "' LIMIT 1 ;";
        $query2 = mysqli_query($link, $sql_select2) or die(mysqli_errno($link));
        if (mysqli_num_rows($query2) == 0) {
          $linkAttributes = $v->link->attributes();
          $url = '';
          if (isset($linkAttributes) && is_array($linkAttributes) && count($linkAttributes) > 0) {
            foreach ($linkAttributes as $key => $value) {
              if ($key == 'href') {
                if ($iso_to_utf == 1) {
                  $url = ((@iconv("UTF-8", "ISO-8859-1//TRANSLIT", $v->link) != false) ? @iconv("UTF-8", "ISO-8859-1//TRANSLIT", $value) : $value);
                } else {
                  $url = $value;
                }
              }
            }
          }

          $sql_insert = "INSERT INTO `feeds_post` (`feeds_id`,`pubDate`,`link`,`title`,`description`) VALUES ('" . $id . "', 
        '" . mysqli_escape_string($link, date('Y-m-d H:i:s', strtotime($v->published))) . "', 
        '" . mysqli_escape_string($link, $url) . "', 
        '" . mysqli_escape_string($link, $v->title) . "', 
        '" . mysqli_escape_string($link, $v->content) . "');";
          mysqli_query($link, $sql_insert) or die(mysqli_errno($link));
        }
        break;
    }
  }
}